unit Unit2;

interface

uses SysUtils, Classes, WinSock;

type
  TReceiveThread = class(TThread)
  private
    fLogMsg: string;
    toEditClientPort: integer;
    toEditClientIP: string;
    FSocket: TSocket;
    procedure DoLogMessage;//   Synchronize
    procedure EditSenderPort;
    procedure EditSenderIP;
  protected
    procedure Execute; override;
    procedure LogMessage(const Msg: string); //      
  public
    constructor Create(aServerSocket: TSocket);
    procedure sendMessageToSender(messageToSend: string);
  end;

implementation

uses Unit1;


constructor TReceiveThread.Create(aServerSocket: TSocket);
begin
  FSocket:= aServerSocket;
  inherited Create(False);//   
end;

procedure TReceiveThread.Execute;
var
  Buffer: array[0..65506] of Byte; //    .     UDP-.
  RecvAddr: TSockAddr; // ,    
  RecvLen,AddrLen: integer;
  Msg: string;
begin
  //       
  repeat
    AddrLen := SizeOf(RecvAddr);
    //  
    RecvLen := recvfrom(FSocket, Buffer, SizeOf(Buffer), 0, RecvAddr, AddrLen);
    //      recvfrom -   .
    if RecvLen < 0 then
    begin
      Synchronize(Form1.OnStopServer);
      Break;
    end;
    SetLength(Msg, RecvLen);//    
    if RecvLen > 0 then
      move(Buffer, Msg[1], RecvLen);//     
    LogMessage('   ' + inet_ntoa(RecvAddr.sin_addr) + ':' +
      IntToStr(ntohs(RecvAddr.sin_port)) + ': ' + Msg);
    toEditClientPort:= ntohs(RecvAddr.sin_port);
    toEditClientIP:= inet_ntoa(RecvAddr.sin_addr);
    Synchronize(EditSenderPort);
    Synchronize(EditSenderIP);
  until False;
  closesocket(FSocket);
end;

procedure TReceiveThread.LogMessage(const Msg: string);
begin
  fLogMsg:= Msg;
  Synchronize(DoLogMessage);
end;

procedure TReceiveThread.EditSenderPort;
begin
  Form1.Edit2.Text:= IntToStr(toEditClientPort);
end;

procedure TReceiveThread.EditSenderIP;
begin
  Form1.Edit3.Text:= toEditClientIP;
end;

procedure TReceiveThread.DoLogMessage;
begin
  Form1.AddMessageToLog(fLogMsg);
end;

procedure TReceiveThread.sendMessageToSender(messageToSend: string);// messageToSend    const messageToSend: string   sendto   (      string     )
var
  SendAddr: TSockAddr;
  SendRes: integer;
begin
  //      ,   
  FillChar(SendAddr.sin_zero,SizeOf(SendAddr.sin_zero),0);
  SendAddr.sin_family:= AF_INET;
  SendAddr.sin_addr.S_addr:= inet_addr(PChar(Form1.Edit3.Text));
//      if SendAddr.sin_addr.S_addr = INADDR_NONE then
  SendAddr.sin_port:= htons(StrToInt(Form1.Edit2.Text));
//  if Length(messageToSend) = 0 then
//    SendRes:= sendto(FSocket,messageToSend,0,0,SendAddr,SizeOf(SendAddr))//   
//  else
//    SendRes:= sendto(FSocket,messageToSend[1],Length(messageToSend),0,SendAddr,SizeOf(SendAddr));// ,  
//    if SendRes < 0 then,       ,   UDP

end;

end.

